%%%----------------------------------------------------------------------
%%% File    : libnet_drv.hrl
%%% Summary : Erlang driver for the libnet
%%%
%%%
%%% NOTICE: This file was generated by the tools of the Erlang Driver
%%%         toolkit.  Do not edit this file by hand unless you know
%%%         what you're doing!
%%%
%%% Copyright (c) 2002, Scott Lystig Fritchie.  All rights reserved.
%%% See the file "LICENSE" at the top of the source distribution for
%%% full license terms.
%%%
%%%----------------------------------------------------------------------

-define(DRV_NAME, "libnet_drv").

-define(MAX_UINT32, 16#FFFFFFFF).

-define(LEN_NUL_TERM, ?MAX_UINT32).

%%%
%%% Driver<->emulator communication codes (xref with top of libnet_drv.h)
%%%

-define(_DEBUG,                         0).
-define(_NULL,                          1).
-define(_LIBNET_OPEN_RAW_SOCK,          2).
-define(_LIBNET_CLOSE_RAW_SOCK,         3).
-define(_MY_LIBNET_SELECT_DEVICE_ANY,   4).
-define(_LIBNET_SELECT_DEVICE,          5).
-define(_LIBNET_OPEN_LINK_INTERFACE,    6).
-define(_LIBNET_CLOSE_LINK_INTERFACE,   7).
-define(_LIBNET_WRITE_IP,               8).
-define(_LIBNET_WRITE_LINK_LAYER,       9).
-define(_LIBNET_DO_CHECKSUM,            10).
-define(_LIBNET_IP_CHECK,               11).
-define(_TEST_SEND_PING,                12).
-define(_TEST_MAKE_ICMP_ECHO_NO_CHECKSUM,  13).

%%%
%%% Constants
%%%

-ifndef(_LIBNET_ERR_BUF).
-define(_LIBNET_ERR_BUF,                128).    % Not defined in Libnet-1.0.2a distribution {sigh}
-endif.
-ifndef(_IPPROTO_IP).
-define(_IPPROTO_IP,                    0).    % dummy for IP
-endif.
-ifndef(_IPPROTO_HOPOPTS).
-define(_IPPROTO_HOPOPTS,               0).    % IP6 hop-by-hop options
-endif.
-ifndef(_IPPROTO_ICMP).
-define(_IPPROTO_ICMP,                  1).    % control message protocol
-endif.
-ifndef(_IPPROTO_IGMP).
-define(_IPPROTO_IGMP,                  2).    % group mgmt protocol
-endif.
-ifndef(_IPPROTO_GGP).
-define(_IPPROTO_GGP,                   3).    % gateway^2 (deprecated)
-endif.
-ifndef(_IPPROTO_IPV4).
-define(_IPPROTO_IPV4,                  4).    % IPv4 encapsulation
-endif.
-ifndef(_IPPROTO_TCP).
-define(_IPPROTO_TCP,                   6).    % tcp
-endif.
-ifndef(_IPPROTO_ST).
-define(_IPPROTO_ST,                    7).    % Stream protocol II
-endif.
-ifndef(_IPPROTO_EGP).
-define(_IPPROTO_EGP,                   8).    % exterior gateway protocol
-endif.
-ifndef(_IPPROTO_PIGP).
-define(_IPPROTO_PIGP,                  9).    % private interior gateway
-endif.
-ifndef(_IPPROTO_RCCMON).
-define(_IPPROTO_RCCMON,                10).    % BBN RCC Monitoring
-endif.
-ifndef(_IPPROTO_NVPII).
-define(_IPPROTO_NVPII,                 11).    % network voice protoco
-endif.
-ifndef(_IPPROTO_PUP).
-define(_IPPROTO_PUP,                   12).    % pup
-endif.
-ifndef(_IPPROTO_ARGUS).
-define(_IPPROTO_ARGUS,                 13).    % Argus
-endif.
-ifndef(_IPPROTO_EMCON).
-define(_IPPROTO_EMCON,                 14).    % EMCON
-endif.
-ifndef(_IPPROTO_XNET).
-define(_IPPROTO_XNET,                  15).    % Cross Net Debugger
-endif.
-ifndef(_IPPROTO_CHAOS).
-define(_IPPROTO_CHAOS,                 16).    % Chao
-endif.
-ifndef(_IPPROTO_UDP).
-define(_IPPROTO_UDP,                   17).    % user datagram protocol
-endif.
-ifndef(_IPPROTO_MUX).
-define(_IPPROTO_MUX,                   18).    % Multiplexing
-endif.
-ifndef(_IPPROTO_MEAS).
-define(_IPPROTO_MEAS,                  19).    % DCN Measurement Subsystems
-endif.
-ifndef(_IPPROTO_HMP).
-define(_IPPROTO_HMP,                   20).    % Host Monitoring
-endif.
-ifndef(_IPPROTO_PRM).
-define(_IPPROTO_PRM,                   21).    % Packet Radio Measurement
-endif.
-ifndef(_IPPROTO_IDP).
-define(_IPPROTO_IDP,                   22).    % xns idp
-endif.
-ifndef(_IPPROTO_TRUNK1).
-define(_IPPROTO_TRUNK1,                23).    % Trunk-1
-endif.
-ifndef(_IPPROTO_TRUNK2).
-define(_IPPROTO_TRUNK2,                24).    % Trunk-2
-endif.
-ifndef(_IPPROTO_LEAF1).
-define(_IPPROTO_LEAF1,                 25).    % Leaf-1
-endif.
-ifndef(_IPPROTO_LEAF2).
-define(_IPPROTO_LEAF2,                 26).    % Leaf-2
-endif.
-ifndef(_IPPROTO_RDP).
-define(_IPPROTO_RDP,                   27).    % Reliable Data
-endif.
-ifndef(_IPPROTO_IRTP).
-define(_IPPROTO_IRTP,                  28).    % Reliable Transaction
-endif.
-ifndef(_IPPROTO_TP).
-define(_IPPROTO_TP,                    29).    % tp-4 w/ class negotiation
-endif.
-ifndef(_IPPROTO_BLT).
-define(_IPPROTO_BLT,                   30).    % Bulk Data Transfer
-endif.
-ifndef(_IPPROTO_NSP).
-define(_IPPROTO_NSP,                   31).    % Network Services
-endif.
-ifndef(_IPPROTO_INP).
-define(_IPPROTO_INP,                   32).    % Merit Internodal
-endif.
-ifndef(_IPPROTO_SEP).
-define(_IPPROTO_SEP,                   33).    % Sequential Exchange
-endif.
-ifndef(_IPPROTO_3PC).
-define(_IPPROTO_3PC,                   34).    % Third Party Connect
-endif.
-ifndef(_IPPROTO_IDPR).
-define(_IPPROTO_IDPR,                  35).    % InterDomain Policy Routing
-endif.
-ifndef(_IPPROTO_XTP).
-define(_IPPROTO_XTP,                   36).    % XTP
-endif.
-ifndef(_IPPROTO_DDP).
-define(_IPPROTO_DDP,                   37).    % Datagram Delivery
-endif.
-ifndef(_IPPROTO_CMTP).
-define(_IPPROTO_CMTP,                  38).    % Control Message Transport
-endif.
-ifndef(_IPPROTO_TPXX).
-define(_IPPROTO_TPXX,                  39).    % TP++ Transport
-endif.
-ifndef(_IPPROTO_IL).
-define(_IPPROTO_IL,                    40).    % IL transport protocol
-endif.
-ifndef(_IPPROTO_IPV6).
-define(_IPPROTO_IPV6,                  41).    % IP6 header
-endif.
-ifndef(_IPPROTO_SDRP).
-define(_IPPROTO_SDRP,                  42).    % Source Demand Routing
-endif.
-ifndef(_IPPROTO_ROUTING).
-define(_IPPROTO_ROUTING,               43).    % IP6 routing header
-endif.
-ifndef(_IPPROTO_FRAGMENT).
-define(_IPPROTO_FRAGMENT,              44).    % IP6 fragmentation header
-endif.
-ifndef(_IPPROTO_IDRP).
-define(_IPPROTO_IDRP,                  45).    % InterDomain Routin
-endif.
-ifndef(_IPPROTO_RSVP).
-define(_IPPROTO_RSVP,                  46).    % resource reservation
-endif.
-ifndef(_IPPROTO_GRE).
-define(_IPPROTO_GRE,                   47).    % General Routing Encap.
-endif.
-ifndef(_IPPROTO_MHRP).
-define(_IPPROTO_MHRP,                  48).    % Mobile Host Routing
-endif.
-ifndef(_IPPROTO_BHA).
-define(_IPPROTO_BHA,                   49).    % BHA
-endif.
-ifndef(_IPPROTO_ESP).
-define(_IPPROTO_ESP,                   50).    % IP6 Encap Sec. Payload
-endif.
-ifndef(_IPPROTO_AH).
-define(_IPPROTO_AH,                    51).    % IP6 Auth Header
-endif.
-ifndef(_IPPROTO_INLSP).
-define(_IPPROTO_INLSP,                 52).    % Integ. Net Layer Security
-endif.
-ifndef(_IPPROTO_SWIPE).
-define(_IPPROTO_SWIPE,                 53).    % IP with encryption
-endif.
-ifndef(_IPPROTO_NHRP).
-define(_IPPROTO_NHRP,                  54).    % Next Hop Resolution
-endif.
-ifndef(_IPPROTO_ICMPV6).
-define(_IPPROTO_ICMPV6,                58).    % ICMP6
-endif.
-ifndef(_IPPROTO_NONE).
-define(_IPPROTO_NONE,                  59).    % IP6 no next header
-endif.
-ifndef(_IPPROTO_DSTOPTS).
-define(_IPPROTO_DSTOPTS,               60).    % IP6 destination option
-endif.
-ifndef(_IPPROTO_AHIP).
-define(_IPPROTO_AHIP,                  61).    % any host internal protocol
-endif.
-ifndef(_IPPROTO_CFTP).
-define(_IPPROTO_CFTP,                  62).    % CFTP
-endif.
-ifndef(_IPPROTO_HELLO).
-define(_IPPROTO_HELLO,                 63).    % 'hello' routing protocol
-endif.
-ifndef(_IPPROTO_SATEXPAK).
-define(_IPPROTO_SATEXPAK,              64).    % SATNET/Backroom EXPAK
-endif.
-ifndef(_IPPROTO_KRYPTOLAN).
-define(_IPPROTO_KRYPTOLAN,             65).    % Kryptolan
-endif.
-ifndef(_IPPROTO_RVD).
-define(_IPPROTO_RVD,                   66).    % Remote Virtual Disk
-endif.
-ifndef(_IPPROTO_IPPC).
-define(_IPPROTO_IPPC,                  67).    % Pluribus Packet Core
-endif.
-ifndef(_IPPROTO_ADFS).
-define(_IPPROTO_ADFS,                  68).    % Any distributed FS
-endif.
-ifndef(_IPPROTO_SATMON).
-define(_IPPROTO_SATMON,                69).    % Satnet Monitoring
-endif.
-ifndef(_IPPROTO_VISA).
-define(_IPPROTO_VISA,                  70).    % VISA Protocol
-endif.
-ifndef(_IPPROTO_IPCV).
-define(_IPPROTO_IPCV,                  71).    % Packet Core Utility
-endif.
-ifndef(_IPPROTO_CPNX).
-define(_IPPROTO_CPNX,                  72).    % Comp. Prot. Net. Executive
-endif.
-ifndef(_IPPROTO_CPHB).
-define(_IPPROTO_CPHB,                  73).    % Comp. Prot. HeartBeat
-endif.
-ifndef(_IPPROTO_WSN).
-define(_IPPROTO_WSN,                   74).    % Wang Span Network
-endif.
-ifndef(_IPPROTO_PVP).
-define(_IPPROTO_PVP,                   75).    % Packet Video Protocol
-endif.
-ifndef(_IPPROTO_BRSATMON).
-define(_IPPROTO_BRSATMON,              76).    % BackRoom SATNET Monitoring
-endif.
-ifndef(_IPPROTO_ND).
-define(_IPPROTO_ND,                    77).    % Sun net disk proto (temp.)
-endif.
-ifndef(_IPPROTO_WBMON).
-define(_IPPROTO_WBMON,                 78).    % WIDEBAND Monitoring
-endif.
-ifndef(_IPPROTO_WBEXPAK).
-define(_IPPROTO_WBEXPAK,               79).    % WIDEBAND EXPAK
-endif.
-ifndef(_IPPROTO_EON).
-define(_IPPROTO_EON,                   80).    % ISO cnlp
-endif.
-ifndef(_IPPROTO_VMTP).
-define(_IPPROTO_VMTP,                  81).    % VMTP
-endif.
-ifndef(_IPPROTO_SVMTP).
-define(_IPPROTO_SVMTP,                 82).    % Secure VMTP
-endif.
-ifndef(_IPPROTO_VINES).
-define(_IPPROTO_VINES,                 83).    % Banyon VINES
-endif.
-ifndef(_IPPROTO_TTP).
-define(_IPPROTO_TTP,                   84).    % TTP
-endif.
-ifndef(_IPPROTO_IGP).
-define(_IPPROTO_IGP,                   85).    % NSFNET-IGP
-endif.
-ifndef(_IPPROTO_DGP).
-define(_IPPROTO_DGP,                   86).    % dissimilar gateway prot.
-endif.
-ifndef(_IPPROTO_TCF).
-define(_IPPROTO_TCF,                   87).    % TCF
-endif.
-ifndef(_IPPROTO_IGRP).
-define(_IPPROTO_IGRP,                  88).    % Cisco/GXS IGRP
-endif.
-ifndef(_IPPROTO_OSPFIGP).
-define(_IPPROTO_OSPFIGP,               89).    % OSPFIGP
-endif.
-ifndef(_IPPROTO_SRPC).
-define(_IPPROTO_SRPC,                  90).    % Strite RPC protocol
-endif.
-ifndef(_IPPROTO_LARP).
-define(_IPPROTO_LARP,                  91).    % Locus Address Resoloution
-endif.
-ifndef(_IPPROTO_MTP).
-define(_IPPROTO_MTP,                   92).    % Multicast Transport
-endif.
-ifndef(_IPPROTO_AX25).
-define(_IPPROTO_AX25,                  93).    % AX.25 Frames
-endif.
-ifndef(_IPPROTO_IPEIP).
-define(_IPPROTO_IPEIP,                 94).    % IP encapsulated in IP
-endif.
-ifndef(_IPPROTO_MICP).
-define(_IPPROTO_MICP,                  95).    % Mobile Int.ing control
-endif.
-ifndef(_IPPROTO_SCCSP).
-define(_IPPROTO_SCCSP,                 96).    % Semaphore Comm. security
-endif.
-ifndef(_IPPROTO_ETHERIP).
-define(_IPPROTO_ETHERIP,               97).    % Ethernet IP encapsulation
-endif.
-ifndef(_IPPROTO_ENCAP).
-define(_IPPROTO_ENCAP,                 98).    % encapsulation header
-endif.
-ifndef(_IPPROTO_APES).
-define(_IPPROTO_APES,                  99).    % any private encr. scheme
-endif.
-ifndef(_IPPROTO_GMTP).
-define(_IPPROTO_GMTP,                  100).    % GMT
-endif.
-ifndef(_IPPROTO_IPCOMP).
-define(_IPPROTO_IPCOMP,                108).    % payload compression (IPComp)
-endif.
-ifndef(_IPPROTO_PIM).
-define(_IPPROTO_PIM,                   103).    % Protocol Independent Mcast
-endif.
-ifndef(_IPPROTO_PGM).
-define(_IPPROTO_PGM,                   113).    % PGM
-endif.
-ifndef(_IPPROTO_DIVERT).
-define(_IPPROTO_DIVERT,                254).    % divert pseudo-protocol
-endif.
-ifndef(_IPPROTO_RAW).
-define(_IPPROTO_RAW,                   255).    % raw IP packet
-endif.
-ifndef(_IPPROTO_MAX).
-define(_IPPROTO_MAX,                   256).
-endif.
-ifndef(_IPPORT_RESERVED).
-define(_IPPORT_RESERVED,               1024).
-endif.
-ifndef(_IPPORT_USERRESERVED).
-define(_IPPORT_USERRESERVED,           5000).
-endif.
-ifndef(_IPPORT_HIFIRSTAUTO).
-define(_IPPORT_HIFIRSTAUTO,            49152).
-endif.
-ifndef(_IPPORT_HILASTAUTO).
-define(_IPPORT_HILASTAUTO,             65535).
-endif.
-ifndef(_LIBNET_ARP_H).
-define(_LIBNET_ARP_H,                  28).    % ARP header: 28 bytes
-endif.
-ifndef(_LIBNET_DNS_H).
-define(_LIBNET_DNS_H,                  12).    % DNS header base: 12 bytes
-endif.
-ifndef(_LIBNET_ETH_H).
-define(_LIBNET_ETH_H,                  14).    % Etherner header: 14 bytes
-endif.
-ifndef(_LIBNET_ICMP_H).
-define(_LIBNET_ICMP_H,                 4).    % ICMP header base: 4 bytes
-endif.
-ifndef(_LIBNET_ICMP_ECHO_H).
-define(_LIBNET_ICMP_ECHO_H,            8).    % ICMP_ECHO header: 8 bytes
-endif.
-ifndef(_LIBNET_ICMP_MASK_H).
-define(_LIBNET_ICMP_MASK_H,            12).    % ICMP_MASK header: 12 bytes
-endif.
-ifndef(_LIBNET_ICMP_UNREACH_H).
-define(_LIBNET_ICMP_UNREACH_H,         8).    % ICMP_UNREACH header: 8 bytes
-endif.
-ifndef(_LIBNET_ICMP_TIMXCEED_H).
-define(_LIBNET_ICMP_TIMXCEED_H,        8).    % ICMP_TIMXCEED header: 8 bytes
-endif.
-ifndef(_LIBNET_ICMP_REDIRECT_H).
-define(_LIBNET_ICMP_REDIRECT_H,        8).    % ICMP_REDIRECT header: 8 bytes
-endif.
-ifndef(_LIBNET_ICMP_TS_H).
-define(_LIBNET_ICMP_TS_H,              20).    % ICMP_TIMESTAMP headr:20 bytes
-endif.
-ifndef(_LIBNET_IGMP_H).
-define(_LIBNET_IGMP_H,                 8).    % IGMP header: 8 bytes
-endif.
-ifndef(_LIBNET_IP_H).
-define(_LIBNET_IP_H,                   20).    % IP header: 20 bytes
-endif.
-ifndef(_LIBNET_RIP_H).
-define(_LIBNET_RIP_H,                  24).    % RIP header base: 24 bytes
-endif.
-ifndef(_LIBNET_TCP_H).
-define(_LIBNET_TCP_H,                  20).    % TCP header: 20 bytes
-endif.
-ifndef(_LIBNET_UDP_H).
-define(_LIBNET_UDP_H,                  8).    % UDP header: 8 bytes
-endif.
-ifndef(_LIBNET_VRRP_H).
-define(_LIBNET_VRRP_H,                 8).    % VRRP header: 8 bytes
-endif.

%%%
%%% Verbatim stuff
%%%


%%%
%%% End of autogenerated code
%%%  script = ../../edtk/hrl_template.gsl
%%%  filename = libnet.xml
%%%  gslgen version = 2.000 Beta 1
%%%  date = 2005/08/16
%%%  time = 22:07:21
%%%
